<?php
class FlowsData
{


    private $host = "localhost";
    private $user = "religion_flows";
    private $pass = "xxxx";
    private $db   = "religion_flows";


    protected $dbs;  // connexio

    public function __construct()
    {
        $this->checkProduction();

        $this->dbs = mysqli_connect( $this->host, $this->user, $this->pass, $this->db );
        if ( mysqli_connect_errno() ) {
            printf( "Connect failed: %s\n", mysqli_connect_error() );
            echo json_encode(array('status' => 0, 'message' => 'Couldn\'t connect to the db'));
            exit();
        }

    }

    public function checkProduction()
    {
        if ( ! preg_match( "/ge\.local/", $_SERVER['HTTP_HOST'] ) )
        {
        //password producci
		}

    }

    public function getData()
    {
        $filters = $this->getFilters();

        $query = $this->prepareQuery( $filters );

        $result = $this->executeQuery( $query );

        echo json_encode( $result );

    }

    public function getFilters()//dades seleccionades al formulari
    {

        $filters['destination'] =  filter_var( $_POST["destination"], FILTER_VALIDATE_REGEXP, array ("options" => array("regexp" => "/\w+/") ) ) ;
        $filters['year']        =  filter_var( $_POST["year"], FILTER_VALIDATE_REGEXP, array ("options" => array("regexp" => "/\w+/") ) ) ;
        $filters['country']     =  filter_var( $_POST["country"], FILTER_VALIDATE_REGEXP, array ("options" => array("regexp" => "/\w+/") ) ) ;
        $filters['religion']    =  filter_var( $_POST["religion"], FILTER_VALIDATE_REGEXP, array ("options" => array("regexp" => "/\w+/") ) ) ;

        return $filters;
    }

    public function prepareQuery( $filters )
    {
        if ( $filters['religion'] == 'all' )
            {

            $query_countries='';

            $year = $filters['year'];

            if ( $filters['country'] != 'World' )
            {
                $query_countries= " WHERE country_name = '" . $filters['country'] . "'";
            }

            if ( $filters['destination'] != 'Catalunya' )  // comarca is selected
            {

                if ($query_countries != '' )
                {
                    $query_destination= $query_countries . "AND normalized_nom_comarca_2 = '". $filters['destination'] . "'";
                }
                else
                {
                    $query_destination= "WHERE normalized_nom_comarca_2 = '". $filters['destination'] . "'";
                }
                $query_destination_added = "AND num_immigrants_$year"." <2892";

                $sql = $this->prepareQueryComarques( $filters, $query_destination, $query_destination_added );
            }
            else   // No comarca selected
            {
                $additional_union = $this->prepareUnion ( $filters['year'] );
                $sql= <<<QUERY
(SELECT country_name, normalized_nom_comarca, number
FROM tall_$year
$query_countries
LIMIT 1230)

UNION

$additional_union
QUERY;

            }
        }
        else
        {
            $sql = $this->prepareQueryReligion ( $filters );

        }
        return $sql;
    }

    public function prepareUnion ( $year )
    {
        if ( $year == '2013' ) $other_value = '138,860';
        if ( $year == '2010' ) $other_value = '129,364';
        if ( $year == '2007' ) $other_value = '104,274';
        if ( $year == '2004' ) $other_value = '59,476';
        return "(SELECT 'Other', '', '" . $other_value ."' as number)";
    }

    public function prepareQueryReligion ( $filters )
    {
        $religion = $this->getReligionName ( $filters['religion'] );
        $year     = $filters['year'];
        $additional_query = '';
        if ( $filters['destination'] != 'Catalunya' )
        {
            $additional_query= "AND normalized_nom_comarca_2 = '". $filters['destination'] . "'";
        }

        $sql= <<<QUERY
SELECT country_name, normalized_nom_comarca, num_immigrants_$year as number, percentatge
FROM top_30_$religion
INNER JOIN immigrant i USING (id_pais)
INNER JOIN comarca c USING (id_comarca)
WHERE number > 0
$additional_query
HAVING number>0
ORDER BY percentatge DESC
QUERY;

        return $sql;
    }

    public function getReligionName ( $id_religion )
    {
        if ( $id_religion == 1 ) return 'evangelism';
        if ( $id_religion == 2 ) return 'islam';
        if ( $id_religion == 3 ) return 'jehova';
        if ( $id_religion == 4 ) return 'buddhism';
        if ( $id_religion == 5 ) return 'hinduism';
        if ( $id_religion == 6 ) return 'orthodox';
    }

    public function prepareQueryComarques( $filters, $query_destination, $query_destination_added )
    {
        $year = $filters['year'];
        if ($filters['country'] == 'World' )   // all countries
        {
            $sql = <<<QUERY
(SELECT country_name, normalized_nom_comarca, num_immigrants_$year as number
FROM  pais
INNER JOIN immigrant USING (id_pais)
INNER JOIN comarca USING (id_comarca)
$query_destination
ORDER BY number DESC
LIMIT 30)

UNION

(SELECT "Other", normalized_nom_comarca, SUM( num_immigrants_$year ) as number
FROM pais
INNER JOIN immigrant USING ( id_pais )
INNER JOIN comarca USING ( id_comarca )
$query_destination
$query_destination_added
ORDER BY number DESC)
QUERY;

        }
        else           // a country is selected --> no Other is showed
        {
            $sql = <<<QUERY
SELECT country_name, normalized_nom_comarca, num_immigrants_$year as number
FROM  pais
INNER JOIN immigrant USING (id_pais)
INNER JOIN comarca USING (id_comarca)
$query_destination
ORDER BY number DESC
LIMIT 30
QUERY;

        }

        return $sql;

    }

    public function executeQuery( $sql )
    {
        $result = mysqli_query( $this->dbs, $sql ) or die( mysqli_error( $this->dbs ) );//execute SQL string command
        $info   = array();
        if ( mysqli_num_rows( $result ) > 0 ){
            for ( $x = 0; $x < mysqli_num_rows( $result ); $x++ ) {
                $info[] = mysqli_fetch_assoc( $result );
            }
            return $info;
        }
        else
        {
            return array( 'status' => 0, 'message' => 'Couldn\'t find processing rate for the give PID.' );
        }

    }
}