function drawLinesSmall(dataset,religions){


		var coldata  = [
							'#e1a760', '#d75931','#752726','#402726','#3f7c7d','#9aa6a3',
							'#e1a760', '#d75931','#752726','#402726','#3f7c7d','#9aa6a3',
							'#e1a760', '#d75931','#752726','#402726','#3f7c7d','#9aa6a3',
							'#e1a760', '#d75931','#752726','#402726','#3f7c7d','#9aa6a3',
							'#e1a760', '#d75931','#752726','#402726','#3f7c7d','#9aa6a3',
							'#e1a760', '#d75931','#752726','#402726','#3f7c7d','#9aa6a3'
						];
				
		coldata = filterColor (coldata);

		var labels =["2004","2007","2010","2013"];

		var m = [30, 30, 30, 30]; // margins
		var w = 380 - m[1] - m[3]; // width
		var h = 270 - m[0] - m[2]; // height
		
		
		var x = d3.scale.linear()
			.domain([0,dataset[0].length-1])
			.range([0, w]);

		var y = d3.scale.linear()
			.domain([0, d3.max(dataset,function(d,i){return d3.max(d);})])
			.range([h, 0]);

		var line = d3.svg.line()
			.x(function(d,i) { return x(i); })							
			.y(function(d) { return y(d); });

		var area = d3.svg.area()
			.x(line.x())
			.y1(line.y())
			.y0(y(0));

		var svg = d3.select("#chart_area").append("svg")

			.attr("width", w + m[1] + m[3])
			.attr("height", h + m[0] + m[2]);



    //background
		  svg.append("rect")
			    .attr("x", -2)
				.attr("y", -2)
				.attr("width",  w+4)
				.attr("height", h+4)
				.attr("transform", "translate(" + m[3] + "," + m[0] + " )")
				.classed("area",true);
				
			
		var lines = svg.selectAll( "g" )
		  .data( dataset );


		var aLineContainer = lines
		  .enter().append("g");  

		
		aLineContainer.append("path")
			.attr("class", "line")
			.attr("d", line)
            .attr ("number", function(d,i) {return i;})
            .attr("transform", "translate(" + m[3] + "," + m[0] + ")")
			.style("stroke", function(d, i) { return coldata[i]; });


    aLineContainer.selectAll(".dot")
        .data(function( d, i ) { return d; })
        .enter()
        .append("circle")
        .attr("transform", "translate(" + m[3] + "," + m[0] + ")")
        .attr ("class","dot")
        .attr("r", 2)
         .attr("cx", line.x())
        .attr("cy", line.y());

    var myMouseoverFunction = function(d,i) {

        var circle = d3.select(this);
        var number = $(this).siblings(".line").attr("number");
        var religion = religions[parseInt(number)];
        circle.append("title").text("Centre type: "+printReligion(religion)+"\n"+"Amount: "+d);
    }




    //  X Axis
		var xAxis = d3.svg.axis().scale(x).orient("bottom").ticks(4).tickFormat(function(d,i) { return labels[i]; });
		
		svg.append("svg:g")
		   	 .attr("class", "x axis")
			 .attr("transform", "translate(" + m[1] + "," +( h + m[0]) + ")")
			 .call(xAxis);

        svg.selectAll("circle").on("mouseover",myMouseoverFunction);


    // Y Axis
		var yAxis = d3.svg.axis().scale(y).orient("left").ticks(4);
		
		svg.append("svg:g")
			 .attr("class", "y axis")
			 .attr("transform", "translate(" + m[3] + "," + m[0] + ")")
			 .call(yAxis);
			
		var text1 = svg.append('text').text('CENTRES')
                        .attr('x', 0)
                        .attr('y', 20)
						.classed("axis_label",true);
		
		var text2 = svg.append('text').text('YEAR')
                        .attr('x', 340)
                        .attr('y', 270)
						.classed("axis_label",true);
						





}

function filterColor (coldata)
{
   if ($("#religion_lines").val() != "all")
   {
		var value = $("#religion_lines").val();
		coldata2 = new Array(coldata[value-1]);
   }
   else
   {
		return coldata;
   }
   return coldata2;
}

//-------------------------------------------------------------------------------


function drawLinesBig(dataset,titles){

        var coldata  = [
                                '#e1a760', '#d75931','#752726','#402726','#3f7c7d','#9aa6a3',
                                '#e1a760', '#d75931','#752726','#402726','#3f7c7d','#9aa6a3',
                                '#e1a760', '#d75931','#752726','#402726','#3f7c7d','#9aa6a3',
                                '#e1a760', '#d75931','#752726','#402726','#3f7c7d','#9aa6a3',
                                '#e1a760', '#d75931','#752726','#402726','#3f7c7d','#9aa6a3',
                                '#e1a760', '#d75931','#752726','#402726','#3f7c7d','#9aa6a3'
                            ];

		var labels =["2004","2007","2010","2013"];

		var m = [30, 80, 80, 80]; // margins
		var w = 750 - m[1] - m[3]; // width
		var h = 550 - m[0] - m[2]; // height
		
		
		var x = d3.scale.linear()
			.domain([0,dataset[0].length-1])
			.range([0, w]);

		var y = d3.scale.linear()
			.domain([0, d3.max(dataset,function(d,i){return d3.max(d);})])
			.range([h, 0]);

		var line = d3.svg.line()
			.x(function(d,i) { return x(i); })							
			.y(function(d) { return y(d); });

		var area = d3.svg.area()
			.x(line.x())
			.y1(line.y())
			.y0(y(0));

		var svg = d3.select("#chart_area_big").append("svg")

			.attr("width", w + m[1] + m[3])
			.attr("height", h + m[0] + m[2]);


		  //background
		  svg.append("rect")
			    .attr("x", -2)
				.attr("y", -2)
				.attr("width",  w+4)
				.attr("height", h+4)
				.attr("transform", "translate(" + m[3] + "," + m[0] + " )")
				.classed("area",true);
				
			
		var lines = svg.selectAll( "g" )
		  .data( dataset );

		// for each array, create a 'g' line container
		var aLineContainer = lines
		  .enter().append("g");

		
		aLineContainer.append("path")
			.attr("class", "line")
			.attr("d", line)
            .attr ("number", function(d,i) {return i;})
			.attr("transform", "translate(" + m[3] + "," + m[0] + ")")
            .style("stroke", function(d, i) {return coldata[i]; });


        aLineContainer.selectAll(".dot")
        .data(function( d, i ) { return d; })
        .enter()
        .append("circle")
        .attr("transform", "translate(" + m[3] + "," + m[0] + ")")
        .attr ("class","dot")
        .attr("r", 2)
        /*.style("opacity",0)*/
        .attr("cx", line.x())
        .attr("cy", line.y());

    var myMouseoverFunction = function(d,i) {

        var circle = d3.select(this);
        var number = $(this).siblings(".line").attr("number");
        var title = titles[parseInt(number)];
        circle.append("title").text("Country: "+title+"\n"+"Immigrants: "+addCommas(d));
    }

    //  X Axis
		var xAxis = d3.svg.axis().scale(x).orient("bottom").ticks(4).tickFormat(function(d,i) { return labels[i]; });
		
		svg.append("svg:g")
		   	 .attr("class", "x axis")
			 .attr("transform", "translate(" + m[1] + "," +( h + m[0]) + ")")
			 .call(xAxis);	
		
		
		// Y Axis
		var yAxis = d3.svg.axis().scale(y).orient("left").ticks(4);
		
		svg.append("svg:g")
			 .attr("class", "y axis")
			 .attr("transform", "translate(" + m[3] + "," + m[0] + ")")
			 .call(yAxis);

        svg.selectAll("circle").on("mouseover",myMouseoverFunction);

		var text1 = svg.append('text').text('IMMIGRANTS')
                        .attr('x', 25)
                        .attr('y', 20)
						.classed("axis_label",true);
		
		var text2 = svg.append('text').text('YEAR')
                        .attr('x', 660)
                        .attr('y', 500)
						.classed("axis_label",true);

       if( $("#country_lines").val()=='World')
       {
           svg.append('text').text('Showing TOP 10 immigration origin countries')
               .attr('x',80)
               .attr('y', 510)
               .attr('id','text_footer_big')
               .classed("footer_text",true);
           if($("#religion_lines").val()!='all')
           {
               svg.append('text').text('(according to religion selected)')
                             .attr('x', 340)
                             .attr('y', 510)
                             .classed("footer_text",true);
           }
       }


						
}


function printReligion(religion_id)
{

    if (religion_id == '1') religion_name = 'Evangelist';
    if (religion_id == '2') religion_name = 'Islamic';
    if (religion_id == '3') religion_name = "Jehova's Witnesses";
    if (religion_id == '4') religion_name = 'Buddhist';
    if (religion_id == '5') religion_name = 'Hindu';
    if (religion_id == '6') religion_name = 'Orthodox';


    return religion_name;
}




