function drawGraphic(col, variable, other_value, percentatges)
{
    var  margin ={b:0, t:40, l:470, r:50};
    var column=col;

    var svg = d3.select("#slide2 .content_right #flows_area")
        .append("svg").attr("class","flows") .attr("viewBox", "420 0 1000 1000")
		.append("g").attr("transform","translate("+ margin.l+","+margin.t+")");

    var data = [
            {data:bP.partData(variable,column), id:'Migration', header:["Country","Region", "Immigration"], footer: 'Showing', other: other_value, percentatges: percentatges}
        ];


    bP.draw(data, svg);
}





/*----------------- navigation ----------------------------------------*/
	
	
		$(document).ready(function() {
			
			$(function() { //go always to cover page
				window.location.href = "#Cover";
			});
			
			
			$('#fullpage').fullpage({
				anchors: ['Cover','firstPage', 'secondPage', '3rdPage', '4thpage', 'lastPage'],
				menu: '#navigation',
				onLeave: function(index, nextIndex, direction){
					if(index == '1'&& nextIndex == '2'){
					        $(".menu").fadeIn( );			
					}
					else if (index == '2'&& nextIndex == '1'){
							$(".menu").fadeOut();
						
					}			
				}
			});

            init();
			
		});
		
		

/*-------------- init graphs-----------------------------------------------*/

function init() 
{
    var home = "http://"+window.location.hostname+"/";

    var other_value;

    //init flows
    $.ajax({
        url: home+"bd_flows.php",
        type: "POST",
        data: {
            destination: $("#destination").val(),
            year: $("#year").val(),
            country: $("#country").val(),
            religion: $("#religion").val()
        },
        dataType: "JSON",
        success: function(jsonStr) {
            $(".flows").remove();
            /*$(".footer_text").remove(); */
            var jsonArray = jsonStr ;
            var jsArray = new Array();
            var percentatges = new Array();
            $.each(jsonArray, function(i, item) {
                if (item.country_name == 'Other' )
                {
                    other_value = item.number;
                }
                else
                {
                    jsArray[i]= new Array(item.country_name,item.normalized_nom_comarca,item.number);
                    percentatges[item.country_name]= new Array (item.percentatge);
                }
            });
            drawGraphic(2,jsArray,other_value, percentatges);
        }

    });

    //init bubbles
    $.ajax({
        url: home+"bd_bubbles.php",
        type: "POST",
        data: {
            //religion: $("#religion_b").val(),
            religion: $('input[name=religion_b]:checked').val(),
            year: $("#slider_value").val()
        },
        dataType: "JSON",
        success: function(jsonStr) {
            d3.select("#map_canvas").selectAll("circle").remove();
            var jsonArray2 = jsonStr ;
            var jsArray2 = new Array();
            $.each(jsonArray2, function(i, item) {
                jsArray2[i]= new Array(item.number)
            });
            drawMap(jsArray2);
        }

    });

    // init lines

    $.ajax({
        url: home+"bd_lines.php",
        type: "POST",
        data: {
            religion_lines: $("#religion_lines").val(),
            destination_lines: $("#destination_lines").val(),
            country_lines: $("#country_lines").val()

        },
        dataType: "JSON",
        success: function(jsonStr) {
            d3.select("#chart_area svg").remove();
            var jsonArray2 = jsonStr[0] ;
            var jsArray2 = new Array();
            var religions = new Array();
            $.each(jsonArray2, function(i, item) {
                jsArray2[i]= new Array(parseInt(item.centres_2004), parseInt(item.centres_2007), parseInt(item.centres_2010), parseInt(item.centres_2013))
                religions[i] = item.religion_name;
            });

            d3.select("#chart_area_big svg").remove();

            var jsonArray3 = jsonStr[1] ;
            var jsArray3 = new Array();
            var titles = new Array();
            $.each(jsonArray3, function(i, item) {
                jsArray3[i]= new Array(parseInt(item.i2004), parseInt(item.i2007), parseInt(item.i2010), parseInt(item.i2013))
                titles[i] = item.country_name;
            });

            drawLinesSmall(jsArray2,religions);
            drawLinesBig(jsArray3,titles);
        }

    });

/*-------------- change graphs -----------------------------------------------*/

    $ ("#year, #destination, #country, #religion").change(function (){
        if ($("#religion").val() != 'all') {
            $("#country").attr('disabled', 'disabled').css("background-color", "grey");
            $("#country").val("World");

        }
        else
        {
            $("#country").removeAttr('disabled').css("background-color","black");
        }

        $.ajax({
           url: home+"bd_flows.php",
           type: "POST",
           data: {
                destination: $("#destination").val(),
                year: $("#year").val(),
                country: $("#country").val(),
                religion: $("#religion").val()
           },
            dataType: "JSON",
            success: function(jsonStr) {
                $(".flows").remove();
                /*$(".footer_text").remove();*/
                var jsonArray = jsonStr ;
                var jsArray = new Array();
                var percentatges = new Array();
                $.each(jsonArray, function(i, item) {
                    if (item.country_name == 'Other' )
                    {
                        other_value = item.number;
                    }
                    else
                    {
                        jsArray[i]= new Array(item.country_name,item.normalized_nom_comarca,item.number);
                        percentatges[item.country_name] = new Array (item.percentatge);
                    }
                });
                drawGraphic(2,jsArray,other_value,percentatges);
            }

        });

    });

   // $("#religion_b").change( function(){
    $('input[name=religion_b]').change( function(){
        $.ajax({
            url: home+"bd_bubbles.php",
            type: "POST",
            data: {
                //religion: $("#religion_b").val(),
                religion: $('input[name=religion_b]:checked').val(),
                year: $("#slider_value").val()
            },
            dataType: "JSON",
            success: function(jsonStr) {
                d3.select("#map_canvas").selectAll("circle").remove();
                var jsonArray2 = jsonStr ;
                var jsArray2 = new Array();
                $.each(jsonArray2, function(i, item) {
                    jsArray2[i]= new Array(item.number)
                });
                drawMap(jsArray2);
            }

        });
    });


    $ ("#religion_lines, #destination_lines, #country_lines").change(function (){
        if ($("#religion_lines").val() != 'all') {
            $("#country_lines").attr('disabled', 'disabled').css("background-color", "grey");
            $("#country_lines").val("World");

        }
        else
        {
            $("#country_lines").removeAttr('disabled').css("background-color","black");
        }

        var comarca= $("#destination_lines").find("option:selected").text();
        if(comarca=="All regions"){comarca="Catalonia";}
        $('#religous_centre').append("text").text(comarca);
        $('#religous_centre_Big').append("text").text(comarca);

        $.ajax({

            url: home+"bd_lines.php",
            type: "POST",
            data: {
                religion_lines: $("#religion_lines").val(),
                destination_lines: $("#destination_lines").val(),
                country_lines: $("#country_lines").val()
            },
            dataType: "JSON",
                success: function(jsonStr) {
                d3.select("#chart_area svg").remove();
                var jsonArray2 = jsonStr[0] ;
                var jsArray2 = new Array();
                var religions = new Array();
                $.each(jsonArray2, function(i, item) {
                    jsArray2[i]= new Array(parseInt(item.centres_2004), parseInt(item.centres_2007), parseInt(item.centres_2010), parseInt(item.centres_2013))
                    religions[i] = item.religion_name;
                });

                d3.select("#chart_area_big svg").remove();

                var jsonArray3 = jsonStr[1] ;
                var jsArray3 = new Array();
                var titles = new Array();
                $.each(jsonArray3, function(i, item) {
                    jsArray3[i]= new Array(parseInt(item.i2004), parseInt(item.i2007), parseInt(item.i2010), parseInt(item.i2013))
                    titles[i] = item.country_name;
                });

                drawLinesSmall(jsArray2,religions);
                drawLinesBig(jsArray3,titles);
            }

        });


    });



/*--------------------- mousover behaviour cover / slide4 -------------------------------*/
	

	$(".next").mouseover(function() {
		$(this).after("<p class=\"bubble\">Scroll down to navigate through the interactive</p>");
	});
	$(".next").mouseout(function() {
			$(".bubble").remove(); //selecciono totes les bombolles i les elimino
	});

	
	
	var text_E_figure="<div class=\"figure_text\"><p class=\"community\">Religious community: <span>Evangelist</span></p><p>In today’s Catalonia the largest religious minority are the Evangelists, also known as Protestants. This religious movement is quite heterogeneous since it brings together several churches that defend teachings which are quite different in some cases. In Catalonia we can distinguish two main branches of doctrine:</p><p>On the one hand there is the <span class=\"cursive_text\">established Protestantism</span>, a result of European tradition and which was set up in Catalonia in the early twentieth century. And on the other, there are the Pentecostal churches, which have their origin at the United States and arrived here in the seventies. These last ones have experienced uninterrupted growth since the establishment of Evangelism, supported mainly by the arrival of immigrants from Latin America, Africa and Asia.</p><p>Within this <span class=\"cursive_text\">new Protestantism</span>, it seems that the trend is for each community to create their own organization (not to integrate into existing churches) and the service is developed in the respective languages of origin. So you can find churches led by African pastors with members from countries like Nigeria, Sierra Leone, Liberia, Togo and Ghana in several towns or villages. Or others led by Asian pastors with Chinese and Philippine members. However, the most notable growth has occurred in churches with Latin American parishioners.</p></div>";
    var text_I_figure="<div class=\"figure_text\"><p class=\"community\">Religious community: <span>Islamic</span></p><p>Islam is a relatively recent religion in the Catalan religious map. The first Islamic oratory opened in 1974, but the real growth in this community has taken place especially during the last decade.</p><p>Catalan Muslims are mostly from <span class=\"cursive_text\">Sunni</span> tradition and come mainly from Morocco, Pakistan and sub-Saharan Africa (especially from Senegal and Gambia, and to a lesser extent, from Mauritania and Mali). But there are occasional cases in which the believers come from Algeria, Palestine, Egypt and Lebanon.</p><p>Each one of these groups often creates its own oratory led by an imam who comes specifically from the country of origin or, in a few cases, led by a faithful (in the case of smaller oratories). If we look at the geographical distribution, we can see how the oratories integrated mainly by Moroccan people are spread throughout the country, however, those integrated by immigrants from sub-Saharan Africa are concentrated along the coast of Maresme region, Selva, Gironès and Garrotxa.</p><p>Usually the Muslim group consists exclusively of immigrants, with the exception of three oratories of Barcelona. The <span class=\"cursive_text\">Sufi</span> current is defended in them and the current worshipers who attend there are mainly Catalans converted to Islam.</p></div>";
    var text_J_figure="<div class=\"figure_text\"><p class=\"community\">Religious community: <span>Jehova's Witnesses</span></p><p>Jehovah's Witnesses came to Catalonia in 1940 and, unlike other religious communities which are concentrated in the suburbs of large cities, they were distributed evenly throughout the Catalan territory.</p><p>This distribution is not a coincidence but is part of a planned growth strategy. Similarly, Jehovah's Witnesses have planned the incorporation into their communities of a part of the great wave of immigration that has arrived in recent years.</p><p>In recent years, though many witnesses from Latin America have joined Catalan communities, this has not led to an increase of the number of <span class=\"cursive_text\">Kingdom Halls of Jehovah</span>. Moreover, recently the number of centres has suffered a decline. But this trend is again a result of a planning strategy: They have redistributed <span class=\"cursive_text\">Kingdom Halls</span> by reducing the amount, but creating congregations with greater number of parishioners.</p></div>";
    var text_B_figure="<div class=\"figure_text\"><p class=\"community\">Religious community: <span>Buddhist</span></p><p>Buddhism is composed of numerous beliefs, despite all of them recognizing the figure of Buddha, there is much disparity in terms of doctrine and practice. This heterogeneity moves to Catalonia producing an extremely varied religious map. Catalan Buddhism includes nine traditions: the <span class=\"cursive_text\">Vipassana</span> (<span class=\"cursive_text\">Hinayana</span> current), <span class=\"cursive_text\">Zen, Pure Land,</span> and <span class=\"cursive_text\">Soka Gakkai</span> (all three from <span class=\"cursive_text\">Mahayana</span> current) and <span class=\"cursive_text\">Nyngma, Sakya, Kagyu,</span> and <span class=\"cursive_text\">Geluppa New Kadampa Tradition</span> (all from <span class=\"cursive_text\">Vajarayana</span> current).</p><p><span class=\"cursive_text\">Hinayana</span> Buddhism is basically a small minority in the world and is implemented in the countries of Southeast Asia (Sri Lanka, Thailand, Cambodia, Laos and Vietnam). In Catalonia there is only one center associated with this branch that hosts various nationalities and is in Vallès Oriental.</p><p><span class=\"cursive_text\">Mahayana</span> Buddhism is implemented primarily in China, Japan, Korea and Vietnam. In Catalonia there are several schools and both immigrants and Catalans interested in meditation and Oriental spirituality attend to them.</p><p>Finally, <span class=\"cursive_text\">Vajrayana</span> Buddhism (or <span class=\"cursive_text\">Tantric</span> Buddhism) is practiced in Tibet and Nepal and its different schools are also represented in Catalonia.</p></div>";
    var text_H_figure="<div class=\"figure_text\"><p class=\"community\">Religious community: <span>Hindu</span></p><p>The introduction of Hinduism in Catalonia is not significant and has a high fragmentation of groups. This is due to the triple origin of this tradition:</p><p>The first Hindu groups were established in the seventies and were linked to the <span class=\"cursive_text\">hippy</span> movement. A second group emerged in the nineties, from first contact with yoga and various meditation techniques. Both groups are integrated today in what is known as <span class=\"cursive_text\">neo Hinduism</span>. Finally, the last group is formed by the group of immigrants who arrived mainly in Barcelona and its metropolitan area.</p><p>Immigrants who follow the Hindu tradition in Catalonia usually come from India, Nepal and Bangladesh and they concentrate solely on one of the centers of Barcelona, which is the only one that has an appropriate temple to carry out rituals such as they usually do in India. The other Hindu immigrants have strictly private practices or integrate themselves into some <span class=\"cursive_text\">neo Hindu</span> center (formed mainly by Occidental people) closest to traditional Hindu forms.</p></div>";
    var text_O_figure="<div class=\"figure_text\"><p class=\"community\">Religious community: <span>Orthodox</span></p><p>Orthodoxy is a very minor religion and is relatively recent in Catalonia. The first communities appeared in the seventies and most have been established in the city of Barcelona.</p><p>Despite the fact that before the establishment of the first churches there was a small community of Greeks, is the arrival of immigration from Eastern Europe that has led to the emergence of new centres.</p><p>Orthodox churches are usually organized by geographic communities (depending on the origin country), and apart from Catalans, mainly immigrants from Russia, Ukraine, Georgia, Greece, Romania, Bulgaria, Serbia and Armenia attend. This kind of organization (according to geographic origin), forms groups like <span class=\"cursive_text\">the Greek Orthodox Church, Slavic Orthodox Church, Romania's Orthodox Church, Russian Orthodox Church</span> and <span class=\"cursive_text\">the Coptic Orthodox Church</span> (composed by immigrants from Egypt) .</p></div>";


	$("#slide4 ul li").mouseover(function() {
		var id = $(this).attr('id');
		var text = "text_"+id;
		$("#slide4 .text_box").hide();
        $("#slide4 h2").hide();
		$("#slide4 .info").hide();
		$("#slide4 .content_left").append(eval(text));
	});
	
	$("#slide4 ul li").mouseout(function() {
		$(".figure_text").remove();
        $("#slide4 h2").show();
		$("#slide4 .text_box").show();
		$("#slide4 .info").show();
	});


		
	
		
	/*------------------------------- Slider (Slide1)-----------------------------------------*/
	$( "#slider" ).slider({
        value:2013,
        min: 2004,
        max: 2013,
        step: 3,
		animate: 1
		})
		.each(function() {


        var opt = $(this).data().uiSlider.options;
        var vals = opt.max - opt.min;
        for (var i = 0; i <= vals; i=i+3)
        {
            var prop = (i/vals*100);
            var el = $('<label class=\"slider_label\">' + (i + opt.min) + '</label>').css(
			{position:'absolute',
			left: prop + '%'});

            $("#slider").append(el);

        }

    });

	$("#slider").slider({
        change: function(event, ui) {
			var value = $("#slider").slider("value");
			$("#slider_value").val(value);


            $.ajax({
                url: home+"bd_bubbles.php",
                type: "POST",
                data: {
                    //religion: $("#religion_b").val(),
                    religion: $('input[name=religion_b]:checked').val(),
                    year: $("#slider_value").val()
                },
                dataType: "JSON",
                success: function(jsonStr) {
                    d3.select("#map_canvas").selectAll("circle").remove();
                    var jsonArray2 = jsonStr ;
                    var jsArray2 = new Array();
                    $.each(jsonArray2, function(i, item) {
                        jsArray2[i]= new Array(item.number)
                    });
                    drawMap(jsArray2);
                }

            });
    	}


	});

   /*------------- highlight region -------------------------------------------*/

   var old_value = $("#destination").val();
   
   $("#destination").change(function(){
        var comarca= $("#destination").val();
		d3.select("#mini_map_canvas #p_"+comarca).style("fill","#f55b2c");
		d3.select("#mini_map_canvas #p_"+old_value).style("fill","#cccccc");
		old_value = comarca;

    });


}

function addCommas(nStr)
{
    nStr += '';
    x = nStr.split('.');
    x1 = x[0];
    x2 = x.length > 1 ? '.' + x[1] : '';
    var rgx = /(\d+)(\d{3})/;
    while (rgx.test(x1)) {
        x1 = x1.replace(rgx, '$1' + ',' + '$2');
    }
    return x1 + x2;
}




