<?php

include_once 'flows_data.php';

class LinesData extends FlowsData
{

    public function getFilters()//dades seleccionades al formulari
    {
        $filters['religion']     = filter_var( $_POST["religion_lines"], FILTER_VALIDATE_REGEXP, array ("options" => array("regexp" => "/\w+/") ) ) ;
        $filters['country']      = filter_var( $_POST["country_lines"] , FILTER_VALIDATE_REGEXP, array ("options" => array("regexp" => "/\w+/") ) ) ;
        $filters['destination']  = filter_var( $_POST["destination_lines"] , FILTER_VALIDATE_REGEXP, array ("options" => array("regexp" => "/\w+/") ) ) ;

        return $filters;
    }

    public function prepareQuery ( $filters )
    {
        $sql_small = $this->prepareQuerySmallLines ( $filters );
        $sql_big   = $this->prepareQueryBigLines( $filters );

        return array ('sql_small' => $sql_small, 'sql_big' => $sql_big );
    }

    public function prepareQuerySmallLines( $filters )
    {
        $additional_condition= 'WHERE 1=1';
        $additional_condition_2= 'AND 1=1';

        if ( $filters['destination'] != 'Catalunya' )
        {
            $additional_condition = "WHERE normalized_nom_comarca_2 = '". $filters['destination'] . "'";
        }
        if ( $filters['religion'] != 'all' )
        {
            $additional_condition_2 = 'AND cc.id_religio = ' . $filters['religion'];

        }

        $sql = <<<QUERY
SELECT
    r.id_religio as religion_name,
    SUM(num_centres_2004) as centres_2004,
    SUM(num_centres_2007) as centres_2007,
    SUM(num_centres_2010) as centres_2010,
    SUM(num_centres_2013) as centres_2013
FROM
    centre_culte cc
    INNER JOIN religio r USING (id_religio)
    INNER JOIN comarca c USING (id_comarca)
$additional_condition
$additional_condition_2
GROUP BY cc.id_religio
ORDER BY cc.id_religio

QUERY;
        return $sql;

    }

    public function prepareQueryBigLines ( $filters )
    {
        $additional_condition   = 'WHERE 1=1';
        $additional_condition_2 = 'AND 1=1';

        if ( $filters['country'] != 'World' )
        {
            $additional_condition = "WHERE p.country_name = '" . $filters['country'] . "'";
        }

        $extra_join = '';
        if ( $filters['religion'] != 'all' )
        {
            $religion_name = $this->getReligionName( $filters['religion'] );
            $extra_join = 'INNER JOIN top_30_' . $religion_name . ' USING(id_pais)';
        }

        if ( $filters['destination'] != 'Catalunya' )
        {
            $additional_condition_2 = "AND normalized_nom_comarca_2 = '". $filters['destination'] . "'";
        }

        $sql = <<<QUERY
SELECT
    p.country_name,
    SUM(num_immigrants_2004) as i2004,
    SUM(num_immigrants_2007) as i2007,
    SUM(num_immigrants_2010) as i2010,
    SUM(num_immigrants_2013) as i2013
FROM
    immigrant
    INNER JOIN pais p USING (id_pais)
    INNER JOIN comarca USING (id_comarca)
$extra_join
$additional_condition
$additional_condition_2
GROUP BY id_pais
ORDER BY i2013 DESC
LIMIT 10

QUERY;
        return $sql;
    }

    public function executeQuery( $sql )
    {
        $sql_small  = $sql['sql_small'];
        $sql_big    = $sql['sql_big'];

        $result     = mysqli_query( $this->dbs, $sql_small ) or die( mysqli_error( $this->dbs ) );//execute SQL string command
        $result2    = mysqli_query( $this->dbs, $sql_big ) or die( mysqli_error( $this->dbs ) );//execute SQL string command
        $info   = array();
        if ( mysqli_num_rows( $result ) > 0 ){
            for ( $x = 0; $x < mysqli_num_rows( $result ); $x++ ) {
                $info[0][] = mysqli_fetch_assoc( $result );
            }
            for ( $x = 0; $x < mysqli_num_rows( $result2 ); $x++ ) {
                $info[1][] = mysqli_fetch_assoc( $result2 );
            }
            return $info;
        }
        else
        {
            return array( 'status' => 0, 'message' => 'Couldn\'t find processing rate for the give PID.' );
        }

    }

}
